//
//  FXTableView.swift
//  FXKit
//
//  Created by Kai Özer on 7/21/14.
//  Copyright (c) 2014, 2021 Kai Özer. All rights reserved.
//

import Cocoa

/// This customization of NSTableView adds the following capabilities
///  - Posting FXTableViewDeleteKeyNotification when the delete key is pressed,
///  - Ability to set a custom drag image
///
@objc open class FXTableView : NSTableView
{
  public static let DeleteKeyNotification = "FXTableViewDeleteKeyNotification"

  /// If the drag image is nil then the default drag image (generated by NSTableView) will be used.
  public var dragImage : NSImage? = nil

  open override func keyDown(with keyEvent:NSEvent)
  {
		if let firstChar = keyEvent.charactersIgnoringModifiers?.unicodeScalars.first
		{
      if ( (firstChar == Unicode.Scalar(NSDeleteCharacter)) || (firstChar == Unicode.Scalar(NSBackspaceCharacter)) )
      {
        NotificationCenter.default.post(name:NSNotification.Name(Self.DeleteKeyNotification), object:self)
        return;
      }
    }
    super.keyDown(with: keyEvent)
  }


  open override func dragImageForRows(with dragRows:IndexSet, tableColumns:[NSTableColumn], event:NSEvent, offset:NSPointPointer) -> NSImage
  {
    if dragImage != nil
    {
      return dragImage!
    }
    return super.dragImageForRows(with:dragRows, tableColumns:tableColumns, event:event, offset:offset)
  }
}
